SystemOrganization addCategory: #'EjerciciosPoo-Distance'!

Object subclass: #Distance
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Distance class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:45'!
newWithAmount: anAmount unit: aUnit 
 "Devuelvo una nueva unidad de distancia con el monto y la unidad corresopndientes"

	^self new initializeWithAmount: anAmount andUnit: aUnit
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:53'!
* aNumber

	^Distance newWithAmount: (self amount * aNumber) unit: self unit.
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/13/2013 20:12'!
+ aDistance 
	
	|newAmount amountInMeters sumInMeters|
	
	amountInMeters := self intoMeters amount.
	sumInMeters  := amountInMeters + (aDistance intoMeters) amount.
	newAmount := sumInMeters / (self unit coeficiente).
	
	^Distance newWithAmount: newAmount unit: self unit
	
	
	! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:35'!
- aDistance

	"resta distancias de cualquier unidad y las devuelve en la unidad de self"

	^ self + aDistance negated
	! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:37'!
/ aNumber 
	
	|divisor|
	divisor := 1/aNumber.

	^ self * divisor! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:05'!
< aDistance

	^ (self - aDistance) amount < 0! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:06'!
<= aDistance

	^ (self > aDistance) not! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/13/2013 19:39'!
= anObject
	
	(anObject isKindOf: Distance) ifTrue: [^self intoMeters amount = anObject intoMeters amount] .
	^false
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:05'!
> aDistance

	^ (self - aDistance) amount > 0! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:04'!
>= aDistance

	^ (self < aDistance) not! !

!Distance methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:14'!
amount
	^ amount! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:15'!
between: aDistance and: anotherDistance

	^ (self <= anotherDistance) and:  (self >= aDistance)! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/11/2013 17:21'!
convertTo: aUnit
	"convierte de una unidad a otra"

	|newAmount amountInMeters amountInMetersTruncated|
	
	amountInMeters := self amount * (self unit coeficiente).
	amountInMetersTruncated := amountInMeters truncated.
	
	newAmount := amountInMetersTruncated  / (aUnit coeficiente).
	
	^Distance  newWithAmount: newAmount unit: aUnit
	! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/13/2013 19:55'!
hash

	^self intoMeters amount ! !

!Distance methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:59'!
initializeWithAmount: anAmount andUnit: aUnit 
	
	amount := anAmount.
	unit := aUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:11'!
intoMeters
	"devuelve la distancia en metros"
	|newAmount|
	
	
	newAmount := self amount * (self unit coeficiente).
	
	
	^Distance newWithAmount: newAmount unit: (Unit newWithName: 'meter' andCoeficiente: 1)  .
 	! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:09'!
max: aDistance

	|answer|
	
	(self < aDistance) ifTrue: [ answer := aDistance ]  ifFalse: [ answer := self ] .
	^ answer ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:10'!
min: aDistance

	|answer|
	
	(self > aDistance) ifTrue: [ answer := aDistance ]  ifFalse: [ answer := self ] .
	^ answer ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:52'!
negated

	|amountNegativa|
		
	amountNegativa := (self amount) * (-1).	
	^Distance newWithAmount: amountNegativa unit: self unit! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:14'!
printOn: aStream

	self amount printOn: aStream.
	aStream space.
	self unit printOn: aStream.
	(self amount ~= 1) ifTrue: [aStream nextPut: $s].! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/15/2013 20:47'!
to: aDistance 
     |step |
	step := Distance newWithAmount: 1 unit: self unit. 
	^DistanceInterval from: self to: aDistance by: step. 
  ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/15/2013 20:47'!
to: aStop by: aStep  
	^DistanceInterval  from: self to: aStop by: aStep ! !

!Distance methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:14'!
unit
	^ unit! !

Object subclass: #DistanceInterval
	instanceVariableNames: 'step start stop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

DistanceInterval class
	instanceVariableNames: 'aStart aStop aStep'!

DistanceInterval class
	instanceVariableNames: 'aStart aStop aStep'!

!DistanceInterval class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/15/2013 20:30'!
from: aStart to: aStop by: aStep 
	
	^self new
	 initializeFrom: aStart
	 to: aStop
	 by: aStep! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/13/2013 21:09'!
by
	^step! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/15/2013 20:45'!
do: aBlock
	"Evaluate aBlock for each value of the interval.
	Implementation note: instead of repeatedly incrementing the value
		aValue := aValue + step.
	until stop is reached,
	We prefer to recompute value from start
		aValue := start + (index * step).
	This is better for floating points accuracy, while not degrading Integer and Fraction speed too much.
	Moreover, this is consistent with methods #at: and #size"

	| aValue index size |
	index := 0.
	size := self size.
	[index < size]
		whileTrue: [aValue := start + ( step * index).
			index := index + 1.
			aBlock value: aValue]! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/13/2013 21:08'!
from
	^start! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/15/2013 20:32'!
initializeFrom: aStart to: aStop by: aStep 
	start := aStart.
	stop := aStop.
	step := aStep! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/15/2013 20:43'!
size 
	|zeroDistance distanceIntervalAmount stepAmount|
	
	zeroDistance := Distance newWithAmount: 0 unit: (self from unit).
	distanceIntervalAmount := (stop - start) intoMeters amount.
	stepAmount  := step intoMeters  amount.

	step < zeroDistance 
		ifTrue: [start < stop
				ifTrue: [^ 0]
				ifFalse: [^  distanceIntervalAmount // stepAmount + 1]]
		ifFalse: [stop < start
				ifTrue: [^ 0]
				ifFalse: [^ distanceIntervalAmount // stepAmount + 1]]! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/15/2013 20:33'!
start
	self shouldBeImplemented.
	^ start! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/13/2013 21:08'!
to
	^stop! !

Object subclass: #Unit
	instanceVariableNames: 'name coeficiente'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Unit class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:24'!
newWithName: aName andCoeficiente: aQuotient 

	^self new initializeWithName: aName andCoeficiente: aQuotient
	! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Ezequiel 11/7/2012 19:24'!
= aUnit

	^(name = aUnit name) and: (coeficiente = aUnit coeficiente).
	! !

!Unit methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:00'!
coeficiente 

	^coeficiente ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:25'!
initializeWithName: aName andCoeficiente: aQuotient  

	name := aName.
	coeficiente := aQuotient! !

!Unit methodsFor: 'accessing' stamp: 'Ezequiel 11/5/2012 20:43'!
name
	^ name! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Ezequiel 11/9/2012 15:14'!
printOn: aStream
	
	aStream nextPutAll:  self name! !

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

DistanceTest class
	instanceVariableNames: 'test07dDistancesCanBeConvertedToDifferentUnits'!

DistanceTest class
	instanceVariableNames: 'test07dDistancesCanBeConvertedToDifferentUnits'!

!DistanceTest methodsFor: 'distance units' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:26'!
centimeter
	
	^Unit newWithName: 'centimeter' andCoeficiente: 0.01! !

!DistanceTest methodsFor: 'distance units' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:27'!
decameter
	
	^Unit newWithName: 'decameter' andCoeficiente: 10! !

!DistanceTest methodsFor: 'distance units' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:27'!
decimeter
	
	^Unit newWithName: 'decimeter' andCoeficiente: 0.1! !

!DistanceTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:27'!
hectometer
	
	^Unit newWithName: 'hectometer' andCoeficiente: 100! !

!DistanceTest methodsFor: 'distance units' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:34'!
kilometer
	
		^Unit newWithName: 'kilometer' andCoeficiente: 1000! !

!DistanceTest methodsFor: 'distance units' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:35'!
meter

	^Unit newWithName: 'meter' andCoeficiente: 1! !

!DistanceTest methodsFor: 'distance units' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:35'!
millimeter
	
	^Unit newWithName: 'millimeter' andCoeficiente: 0.001! !

!DistanceTest methodsFor: 'distance measures' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:40'!
minusOneMeter 
	
	^Distance newWithAmount: -1 unit: self meter ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:41'!
oneCentimeter
	
		^Distance newWithAmount: 1 unit: self centimeter ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:41'!
oneHundredCentimeters
	
	^Distance newWithAmount: 100 unit: self centimeter! !

!DistanceTest methodsFor: 'distance measures' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 22:41'!
oneMeter
	
	^Distance newWithAmount: 1 unit: self meter ! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 15:04'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'EmilianoMenendezEzequielNicols 5/11/2013 17:11'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:56'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:56'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/21/2011 17:24'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:58'!
test21DistancesProvideATotalOrder

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:01'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distanceExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:02'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'EmilianoMenendezEzequielNicols 5/9/2013 00:02'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:19'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:27'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:02'!
twoHundredCentimeters
	
	^Distance newWithAmount: 200 unit: self centimeter ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:02'!
twoMeters
	
	^Distance newWithAmount: 2 unit: self meter! !

!DistanceTest methodsFor: 'distance measures' stamp: 'EmilianoMenendezEzequielNicols 5/8/2013 23:02'!
zeroMeters

	^Distance newWithAmount: 0 unit: self meter! !
